use anyhow::{Error, Result};
use async_trait::async_trait;

#[async_trait]
pub trait IBaseService<T> {
    async fn get_all(&self) -> Result<Vec<T>, Error>;
    async fn get_by_id(&self, id: i32) -> Result<Option<T>, Error>;
    async fn update(&self, entity: T) -> Result<T, Error>;
    //async fn create(&self, entity: T) -> Result<i32, Error>;
    async fn delete(&self, id: i32) -> Result<bool, Error>;
}
